diff -r -u squid-2.6.STABLE13/configure.in new-STABLE13/configure.in
--- squid-2.6.STABLE13/configure.in     Fri May 11 08:59:36 2007
+++ new-STABLE13/configure.in   Sun May 13 00:59:36 2007
@@ -5,7 +5,7 @@
 dnl
 dnl
 dnl
-AC_INIT(Squid Web Proxy, 2.HEAD-CVS, http://www.squid-cache.org/bugs/, squid)
+AC_INIT(Squid Web Proxy, 2.6STABLE13.v6patch.20070512, http://www.squid-cache.org/bugs/, squid)
 AC_PREREQ(2.52)
 AM_CONFIG_HEADER(include/autoconf.h)
 AC_CONFIG_AUX_DIR(cfgaux) 
diff -r -u squid-2.6.STABLE13/include/rfc1035.h new-STABLE13/include/rfc1035.h
--- squid-2.6.STABLE13/include/rfc1035.h	Fri Apr 28 19:17:18 2006
+++ new-STABLE13/include/rfc1035.h	Sun May 13 00:59:36 2007
@@ -38,6 +38,9 @@
 #if HAVE_SYS_TYPES_H
 #include <sys/types.h>
 #endif
+#if HAVE_SYS_SOCKET_H
+#include <sys/socket.h>
+#endif
 #if HAVE_NETINET_IN_H
 #include <netinet/in.h>
 #endif
@@ -71,6 +74,7 @@
     unsigned int tc:1;
     unsigned int rd:1;
     unsigned int ra:1;
+    unsigned int z:3;
     unsigned int rcode:4;
     unsigned short qdcount;
     unsigned short ancount;
@@ -85,7 +89,12 @@
     size_t sz,
     unsigned short qid,
     rfc1035_query * query);
-extern ssize_t rfc1035BuildPTRQuery(const struct in_addr,
+extern ssize_t rfc1035BuildAAAAQuery(const char *hostname,
+    char *buf,
+    size_t sz,
+    unsigned short qid,
+    rfc1035_query * query);
+extern ssize_t rfc1035BuildPTRQuery(const struct sockaddr *,
     char *buf,
     size_t sz,
     unsigned short qid,
@@ -100,6 +109,7 @@
 extern const char *rfc1035_error_message;
 
 #define RFC1035_TYPE_A 1
+#define RFC1035_TYPE_AAAA 28
 #define RFC1035_TYPE_CNAME 5
 #define RFC1035_TYPE_PTR 12
 #define RFC1035_CLASS_IN 1
diff -r -u squid-2.6.STABLE13/include/util.h new-STABLE13/include/util.h
--- squid-2.6.STABLE13/include/util.h	Sun Dec 10 22:36:23 2006
+++ new-STABLE13/include/util.h	Sun May 13 00:59:36 2007
@@ -104,7 +104,7 @@
 extern void xmalloc_find_leaks(void);
 #endif
 
-typedef struct in_addr SIA;
+typedef struct sockaddr SIA;
 extern int safe_inet_addr(const char *, SIA *);
 extern time_t parse_iso3307_time(const char *buf);
 extern char *base64_decode(const char *coded);
diff -r -u squid-2.6.STABLE13/lib/rfc1035.c new-STABLE13/lib/rfc1035.c
--- squid-2.6.STABLE13/lib/rfc1035.c	Wed May 18 01:56:36 2005
+++ new-STABLE13/lib/rfc1035.c	Sun May 13 00:59:36 2007
@@ -644,7 +644,7 @@
     h.qr = 0;
     h.rd = 1;
     h.opcode = 0;		/* QUERY */
-    h.qdcount = (unsigned int) 1;
+    h.qdcount = 1; 
     offset += rfc1035HeaderPack(buf + offset, sz - offset, &h);
     offset += rfc1035QuestionPack(buf + offset,
 	sz - offset,
@@ -660,6 +660,32 @@
     return offset;
 }
 
+ssize_t
+rfc1035BuildAAAAQuery(const char *hostname, char *buf, size_t sz, unsigned short qid, rfc1035_query * query)
+{
+    static rfc1035_message h;
+    size_t offset = 0;
+    memset(&h, '\0', sizeof(h));
+    h.id = qid;
+    h.qr = 0;
+    h.rd = 1;
+    h.opcode = 0;		/* QUERY */
+    h.qdcount = 1;
+    offset += rfc1035HeaderPack(buf + offset, sz - offset, &h);
+    offset += rfc1035QuestionPack(buf + offset,
+	sz - offset,
+	hostname,
+	RFC1035_TYPE_AAAA,
+	RFC1035_CLASS_IN);
+    if (query) {
+	query->qtype = RFC1035_TYPE_AAAA;
+	query->qclass = RFC1035_CLASS_IN;
+	xstrncpy(query->name, hostname, sizeof(query->name));
+    }
+    assert(offset <= sz);
+    return offset;
+}
+
 /*
  * rfc1035BuildPTRQuery()
  * 
@@ -671,19 +697,45 @@
  * Returns the size of the query
  */
 ssize_t
-rfc1035BuildPTRQuery(const struct in_addr addr, char *buf, size_t sz, unsigned short qid, rfc1035_query * query)
+rfc1035BuildPTRQuery(const struct sockaddr *addr, char *buf, size_t sz, unsigned short qid, rfc1035_query * query)
 {
     static rfc1035_message h;
     size_t offset = 0;
-    static char rev[32];
+    static char rev[100];
     unsigned int i;
     memset(&h, '\0', sizeof(h));
-    i = (unsigned int) ntohl(addr.s_addr);
+    memset(rev, '\0', sizeof(rev));
+    if (addr->sa_family == AF_INET) {
+    i = (unsigned int) ntohl(((struct sockaddr_in *)addr)->sin_addr.s_addr);
     snprintf(rev, 32, "%u.%u.%u.%u.in-addr.arpa.",
 	i & 255,
 	(i >> 8) & 255,
 	(i >> 16) & 255,
 	(i >> 24) & 255);
+    }
+    if (addr->sa_family == AF_INET6) {
+	char temp[16];
+	int sx, ex;
+	u_int8_t ci;
+#if BYTE_ORDER == BIG_ENDIAN
+	sx = 0;
+#elif BYTE_ORDER == LITTLE_ENDIAN
+	sx = 15;
+#endif
+	for (i = 0; i < 16; i++) {
+	    ci = ((struct sockaddr_in6 *)addr)->sin6_addr.s6_addr[sx];
+	    memset(temp, '\0', sizeof(temp));
+	    sprintf(temp, "%x.%x", ci & 0xf, ci & 0xf0);
+	    strcat(rev, temp);
+#if BYTE_ORDER == BIG_ENDIAN
+	    sx++;
+#elif BYTE_ORDER == LITTLE_ENDIAN
+	    sx--;
+#endif
+
+	}
+	strcat(rev, ".ip6.arpa");
+    }
     h.id = qid;
     h.qr = 0;
     h.rd = 1;
diff -r -u squid-2.6.STABLE13/lib/safe_inet_addr.c new-STABLE13/lib/safe_inet_addr.c
--- squid-2.6.STABLE13/lib/safe_inet_addr.c	Thu Feb  8 03:56:51 2001
+++ new-STABLE13/lib/safe_inet_addr.c	Sun May 13 00:59:36 2007
@@ -24,6 +24,9 @@
 #if HAVE_NETINET_IN_H
 #include <netinet/in.h>
 #endif
+#if HAVE_NETDB_H
+#include <netdb.h>
+#endif
 #if HAVE_ARPA_INET_H
 #include <arpa/inet.h>
 #endif
@@ -31,36 +34,18 @@
 #include "snprintf.h"
 
 int
-safe_inet_addr(const char *buf, struct in_addr *addr)
+safe_inet_addr(const char *buf, struct sockaddr *addr)
 {
-    static char addrbuf[32];
-    int a1 = 0, a2 = 0, a3 = 0, a4 = 0;
-    struct in_addr A;
-    char x;
-#if defined(_SQUID_HPUX_)
-    /*
-     * MIYOSHI Tsutomu <mijosxi@ike.tottori-u.ac.jp> says scanning 'buf'
-     * causes a bus error on hppa1.1-hp-hpux9.07, so we
-     * have a broad hack for all HP systems.
-     */
-    static char buftmp[32];
-    snprintf(buftmp, 32, "%s", buf);
-    if (sscanf(buftmp, "%d.%d.%d.%d%c", &a1, &a2, &a3, &a4, &x) != 4)
-#else
-    if (sscanf(buf, "%d.%d.%d.%d%c", &a1, &a2, &a3, &a4, &x) != 4)
-#endif
-	return 0;
-    if (a1 < 0 || a1 > 255)
-	return 0;
-    if (a2 < 0 || a2 > 255)
-	return 0;
-    if (a3 < 0 || a3 > 255)
-	return 0;
-    if (a4 < 0 || a4 > 255)
-	return 0;
-    snprintf(addrbuf, 32, "%d.%d.%d.%d", a1, a2, a3, a4);
-    A.s_addr = inet_addr(addrbuf);
-    if (addr)
-	addr->s_addr = A.s_addr;
+    struct addrinfo hints, *res;
+    int error;
+
+    memset(&hints, 0, sizeof(hints));
+    hints.ai_flags = AI_NUMERICHOST|AI_PASSIVE;
+    hints.ai_family = PF_UNSPEC;
+    error = getaddrinfo(buf, NULL, &hints, &res);
+    if (error) return 0;
+    xmemcpy(addr, res->ai_addr, res->ai_addrlen);
+    freeaddrinfo(res);
     return 1;
+
 }
diff -r -u squid-2.6.STABLE13/src/HttpRequest.c new-STABLE13/src/HttpRequest.c
--- squid-2.6.STABLE13/src/HttpRequest.c	Mon Jul 17 11:31:59 2006
+++ new-STABLE13/src/HttpRequest.c	Sun May 13 00:59:36 2007
@@ -45,8 +45,8 @@
 	stringReset(&req->urlpath, urlpath);
     req->max_forwards = -1;
     req->lastmod = -1;
-    req->client_addr = no_addr;
-    req->my_addr = no_addr;
+    memset(&req->client_addr, 0, sizeof(req->client_addr));
+    memset(&req->my_addr, 0, sizeof(req->client_addr));
     httpHeaderInit(&req->header, hoRequest);
     return req;
 }
@@ -135,8 +135,8 @@
 {
     assert(req && p);
     /* Client info */
-    packerPrintf(p, "Client: %s ", inet_ntoa(req->client_addr));
-    packerPrintf(p, "http_port: %s:%d", inet_ntoa(req->my_addr), req->my_port);
+    packerPrintf(p, "Client: %s ", sockaddr_ntoa(&req->client_addr));
+    packerPrintf(p, "http_port: %s:%d", sockaddr_ntoa(&req->my_addr), req->my_port);
     if (req->auth_user_request && authenticateUserRequestUsername(req->auth_user_request))
 	packerPrintf(p, "user: %s", authenticateUserRequestUsername(req->auth_user_request));
     packerPrintf(p, "\n");
diff -r -u squid-2.6.STABLE13/src/access_log.c new-STABLE13/src/access_log.c
--- squid-2.6.STABLE13/src/access_log.c	Sun Feb  4 06:59:24 2007
+++ new-STABLE13/src/access_log.c	Sun May 13 00:59:36 2007
@@ -445,6 +445,7 @@
 	long int outint = 0;
 	int doint = 0;
 	int dofree = 0;
+	char caddr[80];
 	switch (fmt->type) {
 	case LFT_NONE:
 	    out = "";
@@ -453,13 +454,18 @@
 	    out = fmt->data.string;
 	    break;
 	case LFT_CLIENT_IP_ADDRESS:
-	    out = inet_ntoa(al->cache.caddr);
+	    getnameinfo(&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
+		(char *)NULL, 0, NI_NUMERICHOST);
+	    out = caddr;
 	    break;
 
 	case LFT_CLIENT_FQDN:
-	    out = fqdncache_gethostbyaddr(al->cache.caddr, FQDN_LOOKUP_IF_MISS);
-	    if (!out)
-		out = inet_ntoa(al->cache.caddr);
+	    out = fqdncache_gethostbyaddr((struct sockaddr *)&al->cache.caddr, FQDN_LOOKUP_IF_MISS);
+	    if (!out) {
+		getnameinfo(&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
+		(char *)NULL, 0, NI_NUMERICHOST);
+		out = caddr;
+	    }
 	    break;
 
 	case LFT_CLIENT_PORT:
@@ -478,8 +484,12 @@
 	    /* case LFT_SERVER_PORT: */
 
 	case LFT_LOCAL_IP:
-	    if (al->request)
-		out = inet_ntoa(al->request->my_addr);
+	    if (al->request) {
+		getnameinfo(&al->request->my_addr, 
+		    SOCKLEN(&al->request->my_addr), 
+		    caddr, 80, (char *)NULL, 0, NI_NUMERICHOST);
+		out = caddr;
+	    }
 	    break;
 
 	case LFT_LOCAL_PORT:
@@ -1008,10 +1018,14 @@
 {
     const char *client = NULL;
     const char *user = NULL;
+    char caddr[80];
     if (Config.onoff.log_fqdn)
-	client = fqdncache_gethostbyaddr(al->cache.caddr, FQDN_LOOKUP_IF_MISS);
-    if (client == NULL)
-	client = inet_ntoa(al->cache.caddr);
+	client = fqdncache_gethostbyaddr((struct sockaddr *)&al->cache.caddr, FQDN_LOOKUP_IF_MISS);
+    if (client == NULL) {
+	getnameinfo(&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
+		(char *)NULL, 0, NI_NUMERICHOST);
+	client = caddr;
+    }
     user = accessLogFormatName(al->cache.authuser);
     if (!user)
 	user = accessLogFormatName(al->cache.rfc931);
@@ -1068,10 +1082,14 @@
 {
     const char *client = NULL;
     char *user1 = NULL, *user2 = NULL;
+    char caddr[80];
     if (Config.onoff.log_fqdn)
-	client = fqdncache_gethostbyaddr(al->cache.caddr, 0);
-    if (client == NULL)
-	client = inet_ntoa(al->cache.caddr);
+	client = fqdncache_gethostbyaddr(&al->cache.caddr, FQDN_LOOKUP_IF_MISS);
+    if (client == NULL) {
+	getnameinfo(&al->cache.caddr, SOCKLEN(&al->cache.caddr), caddr, 80,
+		(char *)NULL, 0, NI_NUMERICHOST);
+	client = caddr;
+    }
     user1 = accessLogFormatName(al->cache.authuser);
     user2 = accessLogFormatName(al->cache.rfc931);
     logfilePrintf(logfile, "%s %s %s [%s] \"%s %s HTTP/%d.%d\" %d %" PRINTF_OFF_T " %s:%s",
diff -r -u squid-2.6.STABLE13/src/acl.c new-STABLE13/src/acl.c
--- squid-2.6.STABLE13/src/acl.c	Sun Jan  7 02:22:45 2007
+++ new-STABLE13/src/acl.c	Sun May 13 00:59:36 2007
@@ -53,18 +53,18 @@
 static int aclMatchAcl(struct _acl *, aclCheck_t *);
 static int aclMatchTime(acl_time_data * data, time_t when);
 static int aclMatchUser(void *proxyauth_acl, char *user);
-static int aclMatchIp(void *dataptr, struct in_addr c);
+static int aclMatchIp(void *dataptr, struct sockaddr *c);
 static int aclMatchDomainList(void *dataptr, const char *);
 static int aclMatchIntegerRange(intrange * data, int i);
 static int aclMatchWordList(wordlist *, const char *);
 static void aclParseUserMaxIP(void *data);
 static void aclDestroyUserMaxIP(void *data);
 static wordlist *aclDumpUserMaxIP(void *data);
-static int aclMatchUserMaxIP(void *, auth_user_request_t *, struct in_addr);
+static int aclMatchUserMaxIP(void *, auth_user_request_t *, struct sockaddr *);
 static void aclParseHeader(void *data);
 static void aclDestroyHeader(void *data);
 static squid_acl aclStrToType(const char *s);
-static int decode_addr(const char *, struct in_addr *);
+static int decode_addr(const char *, struct sockaddr *);
 static void aclCheck(aclCheck_t * checklist);
 static void aclCheckCallback(aclCheck_t * checklist, allow_t answer);
 #if USE_IDENT
@@ -431,35 +431,31 @@
  * This function should NOT be called if 'asc' is a hostname!
  */
 static int
-decode_addr(const char *asc, struct in_addr *addr)
+decode_addr(const char *asc, struct sockaddr *addr)
 {
-    int a1 = 0, a2 = 0, a3 = 0, a4 = 0;
+    struct addrinfo hints, *res;
+    int error;
 
-    switch (sscanf(asc, "%d.%d.%d.%d", &a1, &a2, &a3, &a4)) {
-    case 4:			/* a dotted quad */
-	if (!safe_inet_addr(asc, addr)) {
-	    debug(28, 0) ("decode_addr: unsafe IP address: '%s'\n", asc);
-	    self_destruct();
-	}
-	break;
-    case 1:			/* a significant bits value for a mask */
-	if (a1 >= 0 && a1 < 33) {
-	    addr->s_addr = a1 ? htonl(0xfffffffful << (32 - a1)) : 0;
-	    break;
-	}
-    default:
+    memset(&hints, 0, sizeof(hints));
+    hints.ai_family = PF_UNSPEC;
+    hints.ai_flags = AI_NUMERICHOST|AI_PASSIVE;
+
+    error = getaddrinfo(asc, NULL, &hints, &res);
+    if (error) {
 	debug(28, 0) ("decode_addr: Invalid IP address '%s'\n", asc);
 	return 0;		/* This is not valid address */
     }
+    xmemcpy(addr, res->ai_addr, SOCKLEN(res->ai_addr));
+    freeaddrinfo(res);
 
     return 1;
 }
 
 
-#define SCAN_ACL1       "%[0123456789.]-%[0123456789.]/%[0123456789.]"
-#define SCAN_ACL2       "%[0123456789.]-%[0123456789.]%c"
-#define SCAN_ACL3       "%[0123456789.]/%[0123456789.]"
-#define SCAN_ACL4       "%[0123456789.]%c"
+#define SCAN_ACL1       "%[0123456789abcdef:.]-%[0123456789abcdef:.]/%[0123456789]"
+#define SCAN_ACL2       "%[0123456789abcdef:.]-%[0123456789abcdef:.]%c"
+#define SCAN_ACL3       "%[0123456789abcdef:.]/%[0123456789]"
+#define SCAN_ACL4       "%[0123456789abcdef:.]%c"
 
 static acl_ip_data *
 aclParseIpData(const char *t)
@@ -468,19 +464,14 @@
     LOCAL_ARRAY(char, addr2, 256);
     LOCAL_ARRAY(char, mask, 256);
     acl_ip_data *q = memAllocate(MEM_ACL_IP_DATA);
-    acl_ip_data *r;
-    acl_ip_data **Q;
-    struct hostent *hp;
-    char **x;
     char c;
     debug(28, 5) ("aclParseIpData: %s\n", t);
     if (!strcasecmp(t, "all")) {
-	q->addr1.s_addr = 0;
-	q->addr2.s_addr = 0;
-	q->mask.s_addr = 0;
+	q->addr1.ss_family = 0;
+	q->addr2.ss_family = 0;
+	q->masklen = 0;
 	return q;
     }
-    q->mask.s_addr = no_addr.s_addr;	/* 255.255.255.255 */
     if (sscanf(t, SCAN_ACL1, addr1, addr2, mask) == 3) {
 	(void) 0;
     } else if (sscanf(t, SCAN_ACL2, addr1, addr2, &c) == 2) {
@@ -489,29 +480,21 @@
 	addr2[0] = '\0';
     } else if (sscanf(t, SCAN_ACL4, addr1, &c) == 1) {
 	addr2[0] = '\0';
-	mask[0] = '\0';
+	strcpy(mask, "-1");
     } else if (sscanf(t, "%[^/]/%s", addr1, mask) == 2) {
 	addr2[0] = '\0';
     } else if (sscanf(t, "%s", addr1) == 1) {
-	/*
-	 * Note, must use plain gethostbyname() here because at startup
-	 * ipcache hasn't been initialized
-	 */
-	if ((hp = gethostbyname(addr1)) == NULL) {
+	struct addrinfo hints, *res;
+	memset(&hints, '\0', sizeof(hints));
+	hints.ai_family = PF_UNSPEC;
+	if (getaddrinfo(t, NULL, &hints, &res)) {
 	    debug(28, 0) ("aclParseIpData: Bad host/IP: '%s'\n", t);
 	    safe_free(q);
 	    return NULL;
 	}
-	Q = &q;
-	for (x = hp->h_addr_list; x != NULL && *x != NULL; x++) {
-	    if ((r = *Q) == NULL)
-		r = *Q = memAllocate(MEM_ACL_IP_DATA);
-	    xmemcpy(&r->addr1.s_addr, *x, sizeof(r->addr1.s_addr));
-	    r->addr2.s_addr = 0;
-	    r->mask.s_addr = no_addr.s_addr;	/* 255.255.255.255 */
-	    Q = &r->next;
-	    debug(28, 3) ("%s --> %s\n", addr1, inet_ntoa(r->addr1));
-	}
+	xmemcpy(&q->addr1, res->ai_addr, res->ai_addrlen);
+	q->masklen = (res->ai_family == AF_INET6) ? 128 : 32;
+	freeaddrinfo(res);
 	return q;
     } else {
 	debug(28, 0) ("aclParseIpData: Bad host/IP: '%s'\n", t);
@@ -519,7 +502,7 @@
 	return NULL;
     }
     /* Decode addr1 */
-    if (!decode_addr(addr1, &q->addr1)) {
+    if (!decode_addr(addr1, (struct sockaddr *)&q->addr1)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
 	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown first address '%s'\n", addr1);
@@ -527,7 +510,7 @@
 	return NULL;
     }
     /* Decode addr2 */
-    if (*addr2 && !decode_addr(addr2, &q->addr2)) {
+    if (*addr2 && !decode_addr(addr2, (struct sockaddr *)&q->addr2)) {
 	debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
 	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown second address '%s'\n", addr2);
@@ -535,19 +518,30 @@
 	return NULL;
     }
     /* Decode mask */
-    if (*mask && !decode_addr(mask, &q->mask)) {
-	debug(28, 0) ("%s line %d: %s\n",
+    if (*mask) {
+	q->masklen = atoi(mask);
+	switch (q->addr1.ss_family) {
+	case AF_INET:
+	    if (q->masklen == -1)
+		q->masklen = 32;
+	    if (q->masklen > 32)
+		q->masklen = -1;
+	    break;
+	case AF_INET6:
+	    if (q->masklen == -1)
+		q->masklen = 128;
+	    if (q->masklen > 128)
+		q->masklen = -1;
+	    break;
+	}
+	if (*mask && (q->masklen == -1)) {
+	    debug(28, 0) ("%s line %d: %s\n",
 	    cfg_filename, config_lineno, config_input_line);
-	debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown netmask '%s'\n", mask);
-	safe_free(q);
-	return NULL;
+	    debug(28, 0) ("aclParseIpData: Ignoring invalid IP acl entry: unknown masklen'%s'\n", mask);
+	    safe_free(q);
+	    return NULL;
+	}
     }
-    if ((q->addr1.s_addr & q->mask.s_addr) != q->addr1.s_addr ||
-	(q->addr2.s_addr & q->mask.s_addr) != q->addr2.s_addr)
-	debug(28, 0) ("aclParseIpData: WARNING: Netmask masks away part of the specified IP in '%s'\n", t);
-    q->addr1.s_addr &= q->mask.s_addr;
-    q->addr2.s_addr &= q->mask.s_addr;
-    /* 1.2.3.4/255.255.255.0  --> 1.2.3.0 */
     return q;
 }
 
@@ -1295,7 +1289,7 @@
 /**************/
 
 static int
-aclMatchIp(void *dataptr, struct in_addr c)
+aclMatchIp(void *dataptr, struct sockaddr *c)
 {
     splayNode **Top = dataptr;
     acl_ip_data x;
@@ -1308,13 +1302,12 @@
      * XXX Could eliminate these repetitive assignments with a
      * static structure.
      */
-    x.addr1 = c;
-    x.addr2 = any_addr;
-    x.mask = no_addr;
+    xmemcpy(&x.addr1, c, SOCKLEN(c));
+    x.masklen = 0;
     x.next = NULL;
     *Top = splay_splay(&x, *Top, aclIpAddrNetworkCompare);
     debug(28, 3) ("aclMatchIp: '%s' %s\n",
-	inet_ntoa(c), splayLastResult ? "NOT found" : "found");
+	sockaddr_ntoa(c), splayLastResult ? "NOT found" : "found");
     return !splayLastResult;
 }
 
@@ -1549,7 +1542,7 @@
  */
 int
 aclMatchUserMaxIP(void *data, auth_user_request_t * auth_user_request,
-    struct in_addr src_addr)
+    struct sockaddr *src_addr)
 {
 /*
  * the logic for flush the ip list when the limit is hit vs keep
@@ -1714,7 +1707,7 @@
     }
     /* get authed here */
     /* Note: this fills in checklist->auth_user_request when applicable (auth incomplete) */
-    switch (authenticateTryToAuthenticateAndSetAuthUser(&checklist->auth_user_request, headertype, checklist->request, checklist->conn, checklist->src_addr)) {
+    switch (authenticateTryToAuthenticateAndSetAuthUser(&checklist->auth_user_request, headertype, checklist->request, checklist->conn, &checklist->src_addr)) {
     case AUTH_ACL_CANNOT_AUTHENTICATE:
 	debug(28, 4) ("aclMatchAcl: returning  0 user authenticated but not authorised.\n");
 	return 0;
@@ -1785,16 +1778,16 @@
     debug(28, 3) ("aclMatchAcl: checking '%s'\n", ae->cfgline);
     switch (ae->type) {
     case ACL_SRC_IP:
-	return aclMatchIp(&ae->data, checklist->src_addr);
+	return aclMatchIp(&ae->data, (struct sockaddr *)&checklist->src_addr);
 	/* NOTREACHED */
     case ACL_MY_IP:
-	return aclMatchIp(&ae->data, checklist->my_addr);
+	return aclMatchIp(&ae->data, (struct sockaddr *)&checklist->my_addr);
 	/* NOTREACHED */
     case ACL_DST_IP:
 	ia = ipcache_gethostbyname(r->host, IP_LOOKUP_IF_MISS);
 	if (ia) {
 	    for (k = 0; k < (int) ia->count; k++) {
-		if (aclMatchIp(&ae->data, ia->in_addrs[k]))
+		if (aclMatchIp(&ae->data, (struct sockaddr *)&ia->in_addrs[k]))
 		    return 1;
 	    }
 	    return 0;
@@ -1812,24 +1805,24 @@
 	    return 1;
 	if ((ia = ipcacheCheckNumeric(r->host)) == NULL)
 	    return 0;
-	fqdn = fqdncache_gethostbyaddr(ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
 	if (fqdn)
 	    return aclMatchDomainList(&ae->data, fqdn);
 	if (checklist->state[ACL_DST_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, inet_ntoa(ia->in_addrs[0]));
+		ae->name, sockaddr_ntoa(&ia->in_addrs[0])); 
 	    checklist->state[ACL_DST_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
 	return aclMatchDomainList(&ae->data, "none");
 	/* NOTREACHED */
     case ACL_SRC_DOMAIN:
-	fqdn = fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&checklist->src_addr, FQDN_LOOKUP_IF_MISS);
 	if (fqdn) {
 	    return aclMatchDomainList(&ae->data, fqdn);
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, inet_ntoa(checklist->src_addr));
+		ae->name, ""); /*XXX inet_ntoa(checklist->src_addr)); */
 	    checklist->state[ACL_SRC_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
@@ -1840,24 +1833,24 @@
 	    return 1;
 	if ((ia = ipcacheCheckNumeric(r->host)) == NULL)
 	    return 0;
-	fqdn = fqdncache_gethostbyaddr(ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&ia->in_addrs[0], FQDN_LOOKUP_IF_MISS);
 	if (fqdn)
 	    return aclMatchRegex(ae->data, fqdn);
 	if (checklist->state[ACL_DST_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, inet_ntoa(ia->in_addrs[0]));
+		ae->name, sockaddr_ntoa(&ia->in_addrs[0])); 
 	    checklist->state[ACL_DST_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
 	return aclMatchRegex(ae->data, "none");
 	/* NOTREACHED */
     case ACL_SRC_DOM_REGEX:
-	fqdn = fqdncache_gethostbyaddr(checklist->src_addr, FQDN_LOOKUP_IF_MISS);
+	fqdn = fqdncache_gethostbyaddr((struct sockaddr *)&checklist->src_addr, FQDN_LOOKUP_IF_MISS);
 	if (fqdn) {
 	    return aclMatchRegex(ae->data, fqdn);
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NONE) {
 	    debug(28, 3) ("aclMatchAcl: Can't yet compare '%s' ACL for '%s'\n",
-		ae->name, inet_ntoa(checklist->src_addr));
+		ae->name, sockaddr_ntoa(&checklist->src_addr));
 	    checklist->state[ACL_SRC_DOMAIN] = ACL_LOOKUP_NEEDED;
 	    return 0;
 	}
@@ -1887,7 +1880,7 @@
 	return k;
 	/* NOTREACHED */
     case ACL_MAXCONN:
-	k = clientdbEstablished(checklist->src_addr, 0);
+	k = clientdbEstablished((struct sockaddr *)&checklist->src_addr, 0);
 	return ((k > ((intlist *) ae->data)->i) ? 1 : 0);
 	/* NOTREACHED */
     case ACL_URL_PORT:
@@ -1950,7 +1943,7 @@
 	if ((ti = aclAuthenticated(checklist)) != 1)
 	    return ti;
 	ti = aclMatchUserMaxIP(ae->data, r->auth_user_request,
-	    checklist->src_addr);
+	    (struct sockaddr *)&checklist->src_addr);
 	return ti;
 	/* NOTREACHED */
 #if SQUID_SNMP
@@ -1959,13 +1952,13 @@
 	/* NOTREACHED */
 #endif
     case ACL_SRC_ASN:
-	return asnMatchIp(ae->data, checklist->src_addr);
+	return asnMatchIp(ae->data, &checklist->src_addr);
 	/* NOTREACHED */
     case ACL_DST_ASN:
 	ia = ipcache_gethostbyname(r->host, IP_LOOKUP_IF_MISS);
 	if (ia) {
 	    for (k = 0; k < (int) ia->count; k++) {
-		if (asnMatchIp(ae->data, ia->in_addrs[k]))
+		if (asnMatchIp(ae->data, &ia->in_addrs[k]))
 		    return 1;
 	    }
 	    return 0;
@@ -1974,7 +1967,7 @@
 		ae->name, r->host);
 	    checklist->state[ACL_DST_ASN] = ACL_LOOKUP_NEEDED;
 	} else {
-	    return asnMatchIp(ae->data, no_addr);
+	    return asnMatchIp(ae->data, &no_addr);
 	}
 	return 0;
 	/* NOTREACHED */
@@ -2166,7 +2159,7 @@
 	    return;
 	} else if (checklist->state[ACL_SRC_DOMAIN] == ACL_LOOKUP_NEEDED) {
 	    checklist->state[ACL_SRC_DOMAIN] = ACL_LOOKUP_PENDING;
-	    fqdncache_nbgethostbyaddr(checklist->src_addr,
+	    fqdncache_nbgethostbyaddr((struct sockaddr *)&checklist->src_addr,
 		aclLookupSrcFQDNDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_DST_DOMAIN] == ACL_LOOKUP_NEEDED) {
@@ -2177,7 +2170,7 @@
 	    }
 	    checklist->dst_addr = ia->in_addrs[0];
 	    checklist->state[ACL_DST_DOMAIN] = ACL_LOOKUP_PENDING;
-	    fqdncache_nbgethostbyaddr(checklist->dst_addr,
+	    fqdncache_nbgethostbyaddr((struct sockaddr *)&checklist->dst_addr,
 		aclLookupDstFQDNDone, checklist);
 	    return;
 	} else if (checklist->state[ACL_PROXY_AUTH] == ACL_LOOKUP_NEEDED) {
@@ -2199,7 +2192,7 @@
 	else if (checklist->state[ACL_IDENT] == ACL_LOOKUP_NEEDED) {
 	    debug(28, 3) ("aclCheck: Doing ident lookup\n");
 	    if (cbdataValid(checklist->conn)) {
-		identStart(&checklist->conn->me, &checklist->conn->peer,
+		identStart((struct sockaddr *)&checklist->conn->me, (struct sockaddr *)&checklist->conn->peer,
 		    aclLookupIdentDone, checklist);
 		checklist->state[ACL_IDENT] = ACL_LOOKUP_PENDING;
 		return;
@@ -2382,11 +2375,11 @@
 	checklist->request = requestLink(request);
 #if FOLLOW_X_FORWARDED_FOR
 	if (Config.onoff.acl_uses_indirect_client) {
-	    checklist->src_addr = request->indirect_client_addr;
+	    xmemcpy(&checklist->src_addr, &request->indirect_client_addr, sizeof(struct sockaddr_storage));
 	} else
 #endif /* FOLLOW_X_FORWARDED_FOR */
-	    checklist->src_addr = request->client_addr;
-	checklist->my_addr = request->my_addr;
+	xmemcpy(&checklist->src_addr, &request->client_addr, sizeof(struct sockaddr_storage));
+	xmemcpy(&checklist->my_addr, &request->my_addr, sizeof(struct sockaddr_storage));
 	checklist->my_port = request->my_port;
     }
     for (i = 0; i < ACL_ENUM_MAX; i++)
@@ -2665,19 +2658,7 @@
 static void
 aclIpDataToStr(const acl_ip_data * ip, char *buf, int len)
 {
-    char b1[20];
-    char b2[20];
-    char b3[20];
-    snprintf(b1, 20, "%s", inet_ntoa(ip->addr1));
-    if (ip->addr2.s_addr != any_addr.s_addr)
-	snprintf(b2, 20, "-%s", inet_ntoa(ip->addr2));
-    else
-	b2[0] = '\0';
-    if (ip->mask.s_addr != no_addr.s_addr)
-	snprintf(b3, 20, "/%s", inet_ntoa(ip->mask));
-    else
-	b3[0] = '\0';
-    snprintf(buf, len, "%s%s%s", b1, b2, b3);
+    sprintf(buf, len, "%s/%d", sockaddr_ntoa(&ip->addr1), ip->masklen);
 }
 
 /*
@@ -2690,27 +2671,77 @@
 static int
 aclIpNetworkCompare2(const acl_ip_data * p, const acl_ip_data * q)
 {
-    struct in_addr A = p->addr1;
-    const struct in_addr B = q->addr1;
-    const struct in_addr C = q->addr2;
-    int rc = 0;
-    A.s_addr &= q->mask.s_addr;	/* apply netmask */
-    if (C.s_addr == 0) {	/* single address check */
-	if (ntohl(A.s_addr) > ntohl(B.s_addr))
-	    rc = 1;
-	else if (ntohl(A.s_addr) < ntohl(B.s_addr))
-	    rc = -1;
-	else
-	    rc = 0;
-    } else {			/* range address check */
-	if (ntohl(A.s_addr) > ntohl(C.s_addr))
-	    rc = 1;
-	else if (ntohl(A.s_addr) < ntohl(B.s_addr))
-	    rc = -1;
+    if (q->addr1.ss_family < p->addr1.ss_family)
+	return -1;
+    else 
+    if (q->addr1.ss_family > p->addr1.ss_family)
+	return 1;
+    else
+    if (q->addr1.ss_family == AF_INET) {
+	u_int32_t maskedup_B; 
+	u_int32_t A = ntohl(((struct sockaddr_in *)&p->addr1)->sin_addr.s_addr);
+	u_int32_t B = ntohl(((struct sockaddr_in *)&q->addr1)->sin_addr.s_addr);
+
+	if (q->masklen == 0)
+	    return 0;
+
+	maskedup_B = ((B >> (32 - q->masklen)) + 1) << (32 - q->masklen);
+	maskedup_B--;
+
+	if (A < B)
+	    return -1;
+	else if (A > maskedup_B)
+	    return 1;
 	else
-	    rc = 0;
+	    return 0;
+    }
+    else
+    if (q->addr1.ss_family == AF_INET6) {
+
+	int masklen, invmasklen, i, rc;
+	struct in6_addr A, B;
+
+	if (q->masklen == 0)
+	    return 0;
+
+	xmemcpy(&A, &((struct sockaddr_in6 *)&p->addr1)->sin6_addr, sizeof(struct in6_addr));
+	xmemcpy(&B, &((struct sockaddr_in6 *)&q->addr1)->sin6_addr, sizeof(struct in6_addr));
+
+	invmasklen = 128 - q->masklen;
+	masklen = q->masklen;
+
+ 	rc = 0;
+	for (i = 0; i < 16; i=i+4) {
+	    if (masklen >= 32) {
+		if (IN6_NTOHL_N(&A, i) < IN6_NTOHL_N(&B, i))
+		    return -1;
+		else
+		if (IN6_NTOHL_N(&A, i) > IN6_NTOHL_N(&B, i))
+		    return 1;
+		else
+		    masklen = masklen - 32;
+	    }
+	    else if (masklen > 0) {
+		invmasklen = 32 - masklen;
+		debug(28, 3) ("aclIpNetworkCompare2: %s vs %s,\n",
+			sockaddr_ntoa(&p->addr1), sockaddr_ntoa(&q->addr1));
+    		debug(28, 3) ("aclIpNetworkCompare2: %x/%d (%x) vs %x\n",
+			IN6_NTOHL_N(&A, i), masklen,
+			IN6_NTOHL_N(&A, i) & (0xffffffff << invmasklen), 
+			IN6_NTOHL_N(&B, i));
+		if (IN6_NTOHL_N(&A, i) < IN6_NTOHL_N(&B, i))
+		    return -1;
+		else
+		if ((IN6_NTOHL_N(&A, i) & (0xffffffff << invmasklen)) > IN6_NTOHL_N(&B, i))
+		    return 1;
+		else
+		    return 0;
+	    }
+	}
     }
-    return rc;
+    else
+	return 0;
+    return 0;
 }
 
 /*
@@ -2734,16 +2765,14 @@
 	ret = aclIpNetworkCompare2(n1, n2);
     }
     if (ret == 0) {
-	char buf_n1[60];
-	char buf_n2[60];
-	char buf_a[60];
-	aclIpDataToStr(n1, buf_n1, 60);
-	aclIpDataToStr(n2, buf_n2, 60);
-	aclIpDataToStr((acl_ip_data *) a, buf_a, 60);
+	char buf_n1[100];
+	char buf_n2[100];
+	getnameinfo(&n1->addr1, SOCKLEN(&n1->addr1), &buf_n1, 100, NULL, 0, NI_NUMERICHOST);
+	getnameinfo(&n2->addr1, SOCKLEN(&n2->addr1), &buf_n2, 100, NULL, 0, NI_NUMERICHOST);
 	debug(28, 0) ("WARNING: '%s' is a subnetwork of "
 	    "'%s'\n", buf_n1, buf_n2);
 	debug(28, 0) ("WARNING: because of this '%s' is ignored "
-	    "to keep splay tree searching predictable\n", buf_a);
+	    "to keep splay tree searching predictable\n", buf_n1);
 	debug(28, 0) ("WARNING: You should probably remove '%s' "
 	    "from the ACL named '%s'\n", buf_n1, AclMatchedName);
     }
@@ -2794,11 +2823,12 @@
     MemBuf mb;
     wordlist **W = state;
     memBufDefInit(&mb);
-    memBufPrintf(&mb, "%s", inet_ntoa(ip->addr1));
+    memBufPrintf(&mb, "%s", sockaddr_ntoa(&ip->addr1));
+/*
     if (ip->addr2.s_addr != any_addr.s_addr)
-	memBufPrintf(&mb, "-%s", inet_ntoa(ip->addr2));
-    if (ip->mask.s_addr != no_addr.s_addr)
-	memBufPrintf(&mb, "/%s", inet_ntoa(ip->mask));
+	memBufPrintf(&mb, "-%s", sockaddr_ntoa(&ip->addr2));
+*/
+    memBufPrintf(&mb, "/%d", ip->masklen);
     wordlistAdd(W, mb.buf);
     memBufClean(&mb);
 }
@@ -3205,7 +3235,7 @@
 	/* Do lookup */
 	*Top = splay_splay(&arpReq.arp_ha.sa_data, *Top, aclArpCompare);
 	debug(28, 3) ("aclMatchArp: '%s' %s\n",
-	    inet_ntoa(c), splayLastResult ? "NOT found" : "found");
+	    sockaddr_ntoa(c), splayLastResult ? "NOT found" : "found");
 	return (0 == splayLastResult);
     }
     /* lookup list of interface names */
diff -r -u squid-2.6.STABLE13/src/asn.c new-STABLE13/src/asn.c
--- squid-2.6.STABLE13/src/asn.c	Tue Jun  6 07:47:01 2006
+++ new-STABLE13/src/asn.c	Sun May 13 00:59:36 2007
@@ -103,7 +103,7 @@
 /* PUBLIC */
 
 int
-asnMatchIp(void *data, struct in_addr addr)
+asnMatchIp(void *data, struct sockaddr *saddr)
 {
     unsigned long lh;
     struct squid_radix_node *rn;
@@ -111,6 +111,10 @@
     m_int m_addr;
     intlist *a = NULL;
     intlist *b = NULL;
+    struct in_addr addr = ((struct sockaddr_in *)saddr)->sin_addr;
+
+    if (saddr->sa_family == AF_INET6)
+	return 1;
     lh = ntohl(addr.s_addr);
     debug(53, 3) ("asnMatchIp: Called for %s.\n", inet_ntoa(addr));
 
